Boomy = {}

--
-- VARS
--

SLASH_BOOMY1 = "/boomy"

Boomy.initialized = false
Boomy.timeSinceLastUpdate = 0

Boomy.mainFrame = nil
Boomy.spellFrame = nil
Boomy.secondFrame = nil
Boomy.moonfireFrame = nil
Boomy.sunfireFrame = nil
Boomy.starfallFrame = nil
Boomy.starsurgeFrame = nil

Boomy.gcd = nil

Boomy.eclipse = {
	duration = 20,
	power = 0,
	direction = "none",
	startTime = 0,
	remainingTime = 0
}

Boomy.spells = {
	starfire = {
		id = 2912,
		castTime = 0
	},
	wrath = {
		id = 5176,
		castTime = 0
	},
	starsurge = {
		id = 78674,
		castTime = 0,
		charges = 0
	},
	starfall = {
		id = 48505,
		castTime = 0,
		charges = 0,
		expirationTime = 0,
		duration = 8
	},
	moonfire = {
		id = 8921,
		castTime = 0,
		duration = 40,
		expirationTime = 0
	},
	sunfire = {
		id = 93402,
		castTime = 0,
		duration = 24,
		expirationTime = 0
	},
	lunarEmpowerment = {
		id = 164547,
		expirationTime = 0,
		charges = 0
	},
	solarEmpowerment = {
		id = 164545,
		expirationTime = 0,
		charges = 0
	},
	empoweredMoonkin = {
		id = 157228,
		expirationTime = 0
	},
	celestialAlignment = {
		id = 112071,
		expirationTime = 0,
		cooldown = 0,
		cooldownRemaining = 0
	},
	incarnation = {
		id = 102560,
		expirationTime = 0,
		cooldown = 180,
		cooldownRemaining = 0
	}
}

--
-- EVENTS
--

Boomy.events = {}
Boomy.eventFrame =CreateFrame("Frame")

Boomy.eventFrame:SetScript("OnEvent", function(self, event, ...)
	Boomy.events[event](self, ...);
end)

function Boomy.events:ADDON_LOADED(...)
	if Boomy.initialized == false then
		Boomy:Initialize()
	end
end

function Boomy.events:PLAYER_TALENT_UPDATE(...)
	Boomy:UpdateTalents()
end

for k, v in pairs(Boomy.events) do
	Boomy.eventFrame:RegisterEvent(k);
end

Boomy.eventFrame:SetScript("OnUpdate", function(this, elapsed)
	Boomy:OnUpdate(elapsed)
end)

SlashCmdList["BOOMY"] = function (msg, editbox)
	if msg == "lock" then
		Boomy:LockFrame(Boomy.mainFrame)
		print("Boomy is locked")
	elseif msg == "unlock" then
		Boomy:UnlockFrame(Boomy.mainFrame)
		print("Boomy is unlocked")
	elseif msg == "reset" then
		Boomy:ResetFrame(Boomy.mainFrame)
		print("Boomy position reset")
	else
		print("Boomy 1.0.1 (17-02-2015)")
		print("/boomy lock")
		print("/boomy unlock")
		print("/boomy reset")
	end
end

--
-- INITIALIZE
--

function Boomy:Initialize()
	Boomy.initialized = true

	if not BoomyDB then BoomyDB = {} end
	if not BoomyDB.rp then BoomyDB.rp = "CENTER" end
	if not BoomyDB.x then BoomyDB.x = -200 end
	if not BoomyDB.y then BoomyDB.y = 200 end


	print("Boomy 1.0.1 (17-02-2015)")
	print("/boomy")

	--
	-- SPELLS
	--
	for k, spell in pairs(Boomy.spells) do
		spell.name, _, spell.icon, spell.castTime, _, spell.maxRange = GetSpellInfo(spell.id)
	end

	--
	-- FRAMES
	--

	local f, t, fs

	-- mainFrame
	f = CreateFrame("Frame", nil, UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(200)
	f:SetHeight(200)
	f:SetPoint(BoomyDB.rp, BoomyDB.x, BoomyDB.y)
	f:SetBackdrop({
        bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
        tile = true,
        tileSize = 32
	})
	f:SetBackdropColor(0, 0, 0, 0);
	f:SetScript("OnMouseDown", function(self)
		if self:IsMovable() then
			self:StartMoving()
		end
	end)
	f:SetScript("OnMouseUp", function(self)
		self:StopMovingOrSizing()
		local _, _, rp, x, y = self:GetPoint()
		BoomyDB.rp = rp
		BoomyDB.x = x
		BoomyDB.y = y
	end)
	f:Show()

	Boomy.mainFrame = f

	-- spellFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(60)
	f:SetHeight(60)
	f:SetPoint("CENTER", 0, 0)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(30)
	f.fontstring = fs

	Boomy.spellFrame = f

	-- moonfireFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", -15, -45)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.moonfire.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.moonfireFrame = f

	-- sunfireFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", 15, -45)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.sunfire.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.sunfireFrame = f

	-- starfallFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", 45, 15)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.starfall.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.starfallFrame = f

	-- starsurgeFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", 45, -15)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.starsurge.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.starsurgeFrame = f

	-- celestialAlignmentFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", -75, 15)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.celestialAlignment.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.celestialAlignmentFrame = f

	-- incarnationFrame
	f = CreateFrame("Frame", nil, Boomy.mainFrame)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(30)
	f:SetHeight(30)
	f:SetPoint("CENTER", -75, -15)
	f:Show()

	t = f:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(Boomy.spells.incarnation.icon)
	t:SetAllPoints(f)
	f.texture = t

	fs = f:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	fs:SetPoint("CENTER")
	fs:SetTextHeight(15)
	f.fontstring = fs

	Boomy.incarnationFrame = f

	--
	-- TALENTS
	--

	Boomy:UpdateTalents()
end

--
-- MAIN LOOP
--

function Boomy:OnUpdate(elapsed)
	Boomy.timeSinceLastUpdate = Boomy.timeSinceLastUpdate + elapsed

	if (Boomy.timeSinceLastUpdate > 0.025) then
		Boomy:update()
	end
end

--
-- UPDATE
--

function Boomy:update()
	--
	-- UPDATE VARS
	--

	Boomy.timeSinceLastUpdate = 0;

	-- gcd
	Boomy.gcd = 1.5 / ( 1 + GetRangedHaste() / 100 )

	-- eclipse
	Boomy.eclipse.direction = GetEclipseDirection()

	local power = UnitPower("player", SPELL_POWER_ECLIPSE)
	if (Boomy.eclipse.power <= 0 and power > 0) or (Boomy.eclipse.power > 0 and power <= 0) or Boomy.eclipse.power == 0 then
		Boomy.eclipse.startTime = GetTime()
		Boomy.eclipse.remainingTime = Boomy.eclipse.duration
	else
		Boomy.eclipse.remainingTime = Boomy.eclipse.duration + (Boomy.eclipse.startTime - GetTime())
	end

	Boomy.eclipse.power = power

	-- spells casting time
	local castTime
	for k, spell in pairs(Boomy.spells) do
		if spell.castTime then
			_, _, _, castTime = GetSpellInfo(spell.id)
			castTime = castTime / 1000
			if castTime <= Boomy.gcd then
				castTime = Boomy.gcd
			end
			spell.castTime = castTime
		end
	end

	-- starsurge
	Boomy.spells.starsurge.charges = GetSpellCharges(Boomy.spells.starsurge.id)

	-- starfall
	Boomy.spells.starfall.charges = GetSpellCharges(Boomy.spells.starfall.id)
	Boomy.spells.starfall.expirationTime = Boomy:GetBuff(Boomy.spells.starfall.name)

	-- moonfire
	Boomy.spells.moonfire.expirationTime = Boomy:GetDebuff(Boomy.spells.moonfire.name)

	-- sunfire
	Boomy.spells.sunfire.expirationTime = Boomy:GetDebuff(Boomy.spells.sunfire.name)

	-- lunar empowerment
	Boomy.spells.lunarEmpowerment.expirationTime, Boomy.spells.lunarEmpowerment.charges = Boomy:GetBuff(Boomy.spells.lunarEmpowerment.name)

	-- solar empowerment
	Boomy.spells.solarEmpowerment.expirationTime, Boomy.spells.solarEmpowerment.charges = Boomy:GetBuff(Boomy.spells.solarEmpowerment.name)

	-- celestial alignment
	local start
	start, Boomy.spells.celestialAlignment.cooldown = GetSpellCooldown(Boomy.spells.celestialAlignment.id)
	if start ~= 0 then
		Boomy.spells.celestialAlignment.cooldownRemaining = Boomy.spells.celestialAlignment.cooldown - (GetTime() - start)
	else
		Boomy.spells.celestialAlignment.cooldownRemaining = 0
	end

	Boomy.spells.celestialAlignment.expirationTime = Boomy:GetBuff(Boomy.spells.celestialAlignment.name)

	-- empowered moonkin
	Boomy.spells.empoweredMoonkin.expirationTime = Boomy:GetBuff(Boomy.spells.empoweredMoonkin.name)

	-- incarnation
	local start = GetSpellCooldown(Boomy.spells.incarnation.id)
	if start ~= 0 then
		Boomy.spells.incarnation.cooldownRemaining = Boomy.spells.incarnation.cooldown - (GetTime() - start)
	else
		Boomy.spells.incarnation.cooldownRemaining = 0
	end

	Boomy.spells.incarnation.expirationTime = Boomy:GetBuff(Boomy.spells.incarnation.name)

	--
	-- UPDATE FRAME
	--

	-- main frame
	local spell = Boomy:GetSpellToCast()

	Boomy:Draw(Boomy.spellFrame, spell.id)

	if spell.id == Boomy.spells.starfire.id then
		Boomy:SetCounter(Boomy.spellFrame, Boomy.spells.lunarEmpowerment.charges)
	elseif spell.id == Boomy.spells.wrath.id then
		Boomy:SetCounter(Boomy.spellFrame, Boomy.spells.solarEmpowerment.charges)
	else
		Boomy:SetCounter(Boomy.spellFrame, 0)
	end

	-- moonfire frame
	Boomy:SetCounter(Boomy.moonfireFrame, math.ceil(Boomy.spells.moonfire.expirationTime, 0))
	Boomy:DecreaseFrameAlpha(Boomy.moonfireFrame)

	if (Boomy.eclipse.power <= 0 or Boomy.spells.celestialAlignment.expirationTime > 0) and Boomy.spells.moonfire.expirationTime < Boomy.spells.moonfire.duration * 0.3 then -- (lunar eclipse OR celestial alignment) AND moonfire expiration time < moonfire duration * 30%
		Boomy:IncreaseFrameAlpha(Boomy.moonfireFrame)
	end

	-- sunfire frame
	Boomy:SetCounter(Boomy.sunfireFrame, math.ceil(Boomy.spells.sunfire.expirationTime, 0))
	Boomy:DecreaseFrameAlpha(Boomy.sunfireFrame)

	if (Boomy.eclipse.power > 0 or Boomy.spells.celestialAlignment.expirationTime > 0) and Boomy.spells.sunfire.expirationTime < Boomy.spells.sunfire.duration * 0.3 then -- (solar eclipse OR celestial alignment) AND sunfire expiration time < sunfire duration * 30%
		Boomy:IncreaseFrameAlpha(Boomy.sunfireFrame)
	end

	-- starfall frame
	Boomy:SetCounter(Boomy.starfallFrame, Boomy.spells.starfall.charges)
	Boomy:DecreaseFrameAlpha(Boomy.starfallFrame)

	if Boomy.spells.starfall.charges > 0 and Boomy.spells.starfall.expirationTime == 0 then -- starfall charge > 0 AND no starfall running
		Boomy:IncreaseFrameAlpha(Boomy.starfallFrame)
	end

	-- starsurge frame
	Boomy:SetCounter(Boomy.starsurgeFrame, Boomy.spells.starsurge.charges)
	Boomy:DecreaseFrameAlpha(Boomy.starsurgeFrame)

	if Boomy.spells.starsurge.charges > 0 then
		if (Boomy.eclipse.power <= 0 and Boomy.spells.lunarEmpowerment.charges == 0) or (Boomy.eclipse.power > 0 and Boomy.spells.solarEmpowerment.charges == 0) or Boomy.spells.starsurge.charges == 3 then -- (eclipse AND 0 empowerment charge) OR 3 starsurge charges
			Boomy:IncreaseFrameAlpha(Boomy.starsurgeFrame)
		end
	end

	-- celestial alignment frame
	Boomy:SetCounter(Boomy.celestialAlignmentFrame, math.ceil(Boomy.spells.celestialAlignment.expirationTime, 0))
	Boomy:DecreaseFrameAlpha(Boomy.celestialAlignmentFrame)

	if Boomy.spells.celestialAlignment.cooldownRemaining == 0 then -- celestial alignement rdy
		Boomy:IncreaseFrameAlpha(Boomy.celestialAlignmentFrame)
	end

	-- incarnation frame
	Boomy:SetCounter(Boomy.incarnationFrame, math.ceil(Boomy.spells.incarnation.expirationTime, 0))
	Boomy:DecreaseFrameAlpha(Boomy.incarnationFrame)

	if Boomy.spells.incarnation.cooldownRemaining == 0 then -- incarnation rdy
		Boomy:IncreaseFrameAlpha(Boomy.incarnationFrame)
	end
end

--
-- CORE
--

function Boomy:GetSpellToCast()
	-- empowered moonkin
	if Boomy.spells.empoweredMoonkin.expirationTime > 0 then
		return Boomy.spells.empoweredMoonkin
	end

	-- celestial alignment
	if Boomy.spells.celestialAlignment.expirationTime > 0 then
		if Boomy.eclipse.power <= 0 then
			return Boomy.spells.starfire
		else
			return Boomy.spells.wrath
		end
	end

	-- starfire
	if Boomy.eclipse.direction == "none" or (Boomy.eclipse.direction == "moon" and Boomy.eclipse.power <= 0) or (Boomy.eclipse.direction == "sun" and Boomy.eclipse.power < 0 and Boomy.spells.starfire.castTime <= Boomy.eclipse.remainingTime) or (Boomy.eclipse.direction == "moon" and Boomy.eclipse.power > 0 and Boomy.spells.starfire.castTime >= Boomy.eclipse.remainingTime) then
		return Boomy.spells.starfire
	end

	-- wrath
	return Boomy.spells.wrath
end

function Boomy:Draw(frame, spellId)
	frame.texture:SetTexture(GetSpellTexture(spellId))
end

function Boomy:IncreaseFrameAlpha(frame)
	frame.texture:SetAlpha(1)
end

function Boomy:DecreaseFrameAlpha(frame)
	frame.texture:SetAlpha(0.25)
end

function Boomy:SetCounter(frame, count)
	if count > 0 then
		frame.fontstring:SetText(count)
		frame.fontstring:Show()
	else
		frame.fontstring:Hide()
	end
end

function Boomy:GetBuff(buffName)
    local _, _, _, count, _, _, expirationTime = UnitAura("player", buffName, nil, "PLAYER|HELPFUL")
    if (expirationTime ~= nil) then
    	expirationTime = expirationTime - GetTime()
        return expirationTime, count
    else
    	return 0, 0
    end
end

function Boomy:GetDebuff(debuffName)
    local _, _, _, _, _, _, expirationTime = UnitAura("target", debuffName, nil, "PLAYER|HARMFUL")
    if (expirationTime ~= nil) then
    	expirationTime = expirationTime - GetTime()
        return expirationTime
    else
    	return 0
    end
end

function Boomy:UnlockFrame(frame)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetBackdropColor(0, 0, 0, 0.25);
end

function Boomy:LockFrame(frame)
	frame:EnableMouse(false)
	frame:SetMovable(false)
	frame:SetBackdropColor(0, 0, 0, 0);
end

function Boomy:ResetFrame(frame)
	BoomyDB.rp = "CENTER"
	BoomyDB.x = -200
	BoomyDB.y = 200
	frame:SetPoint(BoomyDB.rp, BoomyDB.x, BoomyDB.y)
end

function Boomy:UpdateTalents()
	local _, talent = GetTalentRowSelectionInfo(4)
	if talent == 18579 then
		Boomy.incarnationFrame:Show()
	else
		Boomy.incarnationFrame:Hide()
	end

	local _, talent = GetTalentRowSelectionInfo(7)
	if talent == 21192 then
		Boomy.eclipse.duration = 10
	else
		Boomy.eclipse.duration = 20
	end
end

-- function Boomy:SimulateSpellCast(spell)
-- 	-- eclipse remaining time
-- 	if Boomy.eclipse.remainingTime > spell.castTime then
-- 		Boomy.eclipse.remainingTime = Boomy.eclipse.remainingTime - spell.castTime
-- 	else
-- 		Boomy.eclipse.remainingTime = Boomy.eclipse.duration - (spell.castTime - Boomy.eclipse.remainingTime)
-- 	end

-- 	-- eclipse direction
-- 	if Boomy.eclipse.direction == "moon" and Boomy.eclipse.power <= 0 and Boomy.eclipse.remainingTime < (Boomy.eclipse.duration / 2) then
-- 		Boomy.eclipse.direction = "sun"
-- 	elseif Boomy.eclipse.direction == "sun" and Boomy.eclipse.power > 0 and Boomy.eclipse.remainingTime < (Boomy.eclipse.duration / 2) then
-- 		Boomy.eclipse.direction = "moon"
-- 	end

-- 	-- eclipse power
-- 	local power
-- 	if Boomy.eclipse.remainingTime < (Boomy.eclipse.duration / 2) then
-- 		power = Boomy.eclipse.remainingTime * (200 / Boomy.eclipse.duration)
-- 		if Boomy.eclipse.direction == "sun" then
-- 			power = - power
-- 		end
-- 	else
-- 		power = 100 + (((Boomy.eclipse.duration / 2) - Boomy.eclipse.remainingTime) * (200 / Boomy.eclipse.duration))
-- 		if Boomy.eclipse.direction == "moon" or Boomy.eclipse.direction == "none" then
-- 			power = - power
-- 		end
-- 	end
-- 	Boomy.eclipse.power = power
-- end
